package horst;

import java.util.Stack;
import java.util.Vector;

public class ContextChecker {
   public static final int VALID = 0;
   public static final int IGNORE = 1;

   static int checkContext(Element e, TagStack tagStack, Stack characterStack) {
      switch (e.getType()) {
         case 3:
            return method_5(e, tagStack, characterStack);
         case 4:
         case 5:
            return method_4(e, tagStack);
         case 6:
            return method_3(e, tagStack);
         case 25:
            return method_1(e, tagStack);
         case 26:
            return method_0(e, tagStack);
         case 27:
            return method_2(e, tagStack);
         default:
            return 0;
      }
   }

   // $FF: renamed from: dd (horst.Element, horst.TagStack) int
   private static int method_0(Element e, TagStack tagStack) {
      if (((Stack)tagStack).empty()) {
         return 0;
      } else {
         Element stackElem = (Element)((Stack)tagStack).peek();
         if (stackElem.getType() == 25) {
            return 0;
         } else {
            Element dlElem = tagStack.getElementType(24);
            if (dlElem != null) {
               tagStack.popToElement(dlElem);
               return 0;
            } else {
               return 1;
            }
         }
      }
   }

   // $FF: renamed from: dt (horst.Element, horst.TagStack) int
   private static int method_1(Element e, TagStack tagStack) {
      if (((Stack)tagStack).empty()) {
         return 1;
      } else {
         Element stackElem = (Element)((Stack)tagStack).peek();
         if (stackElem.getType() == 24) {
            return 0;
         } else {
            Element dlElem = tagStack.getElementType(24);
            if (dlElem != null) {
               tagStack.popToElement(dlElem);
               return 0;
            } else {
               return 1;
            }
         }
      }
   }

   // $FF: renamed from: li (horst.Element, horst.TagStack) int
   private static int method_2(Element e, TagStack tagStack) {
      if (!((Stack)tagStack).empty()) {
         Element stackElem = (Element)((Stack)tagStack).peek();
         if (stackElem.getType() == 22 || stackElem.getType() == 79 || stackElem.getType() == 61 || stackElem.getType() == 23) {
            return 0;
         }
      }

      int[] types = new int[3];
      types[0] = 23;
      types[1] = 22;
      types[2] = 61;
      Element targetElem = tagStack.getFirstElementType(types);
      if (targetElem != null) {
         tagStack.popToElement(targetElem);
      } else {
         targetElem = tagStack.getElementType(27);
         if (targetElem != null) {
            tagStack.popElement(targetElem);
         }
      }

      return 0;
   }

   // $FF: renamed from: p (horst.Element, horst.TagStack) int
   private static int method_3(Element e, TagStack tagStack) {
      if (!((Stack)tagStack).empty()) {
         Element stackElem = (Element)((Stack)tagStack).peek();
         if (stackElem.getType() == 6) {
            while(stackElem.getType() == 6) {
               tagStack.pop();
               if (!((Stack)tagStack).empty()) {
                  stackElem = (Element)((Stack)tagStack).peek();
               }
            }

            return 0;
         }

         if (stackElem.getType() == 2) {
            Element row = new Element(3);
            stackElem.addChild(row);
            ((Stack)tagStack).push(row);
            return 0;
         }
      }

      return 0;
   }

   // $FF: renamed from: td (horst.Element, horst.TagStack) int
   private static int method_4(Element e, TagStack tagStack) {
      if (((Stack)tagStack).empty()) {
         return 1;
      } else {
         Element stackElem = (Element)((Stack)tagStack).peek();
         if (stackElem.getType() == 3) {
            return 0;
         } else if (stackElem.getType() == 2) {
            Element row = new Element(3);
            stackElem.addChild(row);
            ((Stack)tagStack).push(row);
            return 0;
         } else {
            Element trElem = tagStack.getElementType(3);
            if (trElem != null) {
               tagStack.popToElement(trElem);
               return 0;
            } else {
               return 1;
            }
         }
      }
   }

   // $FF: renamed from: tr (horst.Element, horst.TagStack, java.util.Stack) int
   private static int method_5(Element e, TagStack tagStack, Stack characterStack) {
      if (((Stack)tagStack).empty()) {
         return 1;
      } else {
         Element stackElem = (Element)((Stack)tagStack).peek();
         if (stackElem.getType() == 2) {
            return 0;
         } else {
            if (stackElem.getType() == 3) {
               Element row = (Element)tagStack.pop();
               if (((Stack)tagStack).empty()) {
                  ((Stack)tagStack).push(row);
                  return 1;
               }

               Element elem = (Element)((Stack)tagStack).peek();
               if (elem.getType() == 2) {
                  return 0;
               }
            } else if (stackElem.getType() != 5 && stackElem.getType() != 4) {
               Element tabElem = tagStack.getElementType(2);
               if (tabElem != null) {
                  tagStack.popToElement(tabElem);
                  return 0;
               }
            } else if (((Vector)tagStack).size() > 1) {
               stackElem = (Element)tagStack.pop();
               if (stackElem.getType() == 4 && !characterStack.empty()) {
                  characterStack.pop();
               }

               Element elem = (Element)((Stack)tagStack).peek();
               if (elem.getType() == 3 && !((Stack)tagStack).empty()) {
                  Element rowElem = (Element)tagStack.pop();
                  Element possibleTable = (Element)((Stack)tagStack).peek();
                  if (possibleTable.getType() == 2) {
                     return 0;
                  }

                  ((Stack)tagStack).push(rowElem);
               }

               ((Stack)tagStack).push(stackElem);
            }

            return 1;
         }
      }
   }
}
