package horst;

public class ViewFactory {
   protected View createView(View parent, Element e, HTMLPane container) {
      View view = null;
      switch (e.getType()) {
         case 0:
            view = new HTMLView(parent, e, container);
            break;
         case 1:
            view = new BodyView(parent, e, container);
            break;
         case 2:
            view = new TableView(parent, e, container);
            break;
         case 6:
         case 14:
         case 15:
         case 16:
         case 17:
         case 18:
         case 19:
            view = new ParagraphView(parent, e, container);
            break;
         case 7:
            view = new BRView(parent, e, container);
            break;
         case 8:
         case 28:
         case 34:
         case 37:
         case 64:
         case 80:
            view = new BlockView(parent, e, container);
            break;
         case 9:
            view = new TextView(parent, e, container);
            break;
         case 10:
            view = new AnchorView(parent, e, container);
            break;
         case 11:
            view = new ImageView(parent, e, container);
            break;
         case 12:
            view = new CenterView(parent, e, container);
            break;
         case 20:
            view = new HRView(parent, e, container);
            break;
         case 21:
            view = new BlockQuoteView(parent, e, container);
            break;
         case 22:
         case 23:
         case 24:
         case 79:
            view = new ListView(parent, e, container);
            break;
         case 25:
         case 26:
         case 27:
            view = new ListItemView(parent, e, container);
            break;
         case 29:
            view = new DIVView(parent, e, container);
            break;
         case 30:
         case 31:
         case 32:
            view = new ComponentView(parent, e, container);
            break;
         case 35:
            view = new FrameSetView(parent, e, container);
            break;
         case 43:
            view = new AppletView(parent, e, container);
            break;
         case 67:
            view = new IFrameView(parent, e, container);
            break;
         case 69:
            view = new SpacerView(parent, e, container);
            break;
         case 71:
         default:
            view = new InvisibleView(parent, e, container);
            break;
         case 101:
            view = new NBSPView(parent, e, container);
      }

      return view;
   }
}
