package horst.parser;

import java.util.Hashtable;

public class HTMLTags implements TagGenerator {
   public final Tag HTML = new Tag(0, true, true);
   public final Tag BODY = new Tag(1, true, true);
   public final Tag TABLE = new Tag(2, true, true);
   // $FF: renamed from: TD horst.parser.Tag
   public final Tag field_0 = new Tag(5, true, true);
   // $FF: renamed from: TH horst.parser.Tag
   public final Tag field_1 = new Tag(4, true, true);
   // $FF: renamed from: TR horst.parser.Tag
   public final Tag field_2 = new Tag(3, true, true);
   // $FF: renamed from: P horst.parser.Tag
   public final Tag field_3 = new Tag(6, true, true);
   public final Tag CENTER = new Tag(12, true, true);
   public final Tag IMG = new Tag(11);
   public final Tag DOCTYPE = new Tag(70);
   // $FF: renamed from: BR horst.parser.Tag
   public final Tag field_4 = new Tag(7, true, false);
   // $FF: renamed from: LI horst.parser.Tag
   public final Tag field_5 = new Tag(27, true, true);
   // $FF: renamed from: H1 horst.parser.Tag
   public final Tag field_6 = new Tag(14, true, true);
   // $FF: renamed from: H2 horst.parser.Tag
   public final Tag field_7 = new Tag(15, true, true);
   // $FF: renamed from: H3 horst.parser.Tag
   public final Tag field_8 = new Tag(16, true, true);
   // $FF: renamed from: H4 horst.parser.Tag
   public final Tag field_9 = new Tag(17, true, true);
   // $FF: renamed from: H5 horst.parser.Tag
   public final Tag field_10 = new Tag(18, true, true);
   // $FF: renamed from: H6 horst.parser.Tag
   public final Tag field_11 = new Tag(19, true, true);
   // $FF: renamed from: UL horst.parser.Tag
   public final Tag field_12 = new Tag(22, true, true);
   public final Tag DIR = new Tag(79, true, true);
   // $FF: renamed from: OL horst.parser.Tag
   public final Tag field_13 = new Tag(23, true, true);
   // $FF: renamed from: HR horst.parser.Tag
   public final Tag field_14 = new Tag(20, true, false);
   // $FF: renamed from: I horst.parser.Tag
   public final Tag field_15 = new Tag(38, false, true);
   // $FF: renamed from: A horst.parser.Tag
   public final Tag field_16 = new Tag(10, false, true);
   public final Tag HEAD = new Tag(8, true, true);
   public final Tag TITLE = new Tag(13, true, true);
   public final Tag META = new Tag(39, true, false);
   public final Tag STRONG = new Tag(40, false, true);
   // $FF: renamed from: EM horst.parser.Tag
   public final Tag field_17 = new Tag(60, false, true);
   public final Tag SMALL = new Tag(41, false, true);
   // $FF: renamed from: B horst.parser.Tag
   public final Tag field_18 = new Tag(42, false, true);
   public final Tag INPUT = new Tag(30, false, false);
   public final Tag PRE = new Tag(28, true, true);
   public final Tag FRAME = new Tag(36);
   public final Tag FRAMESET = new Tag(35, true, true);
   public final Tag NOFRAMES = new Tag(37, true, true);
   public final Tag NOFRAME = new Tag(80, true, true);
   public final Tag IFRAME = new Tag(67, true, true);
   public final Tag APPLET = new Tag(43, true, true);
   // $FF: renamed from: DL horst.parser.Tag
   public final Tag field_19 = new Tag(24, true, true);
   public final Tag PARAM = new Tag(44);
   public final Tag CAPTION = new Tag(45, true, true);
   public final Tag MAP = new Tag(47, true, true);
   public final Tag BLOCKQUOTE = new Tag(21, true, true);
   public final Tag BIG = new Tag(48, false, true);
   public final Tag SCRIPT = new Tag(49, true, true);
   public final Tag AREA = new Tag(50);
   public final Tag DIV = new Tag(29, true, true);
   public final Tag LINK = new Tag(51, true, false);
   public final Tag FONT = new Tag(52, false, true);
   public final Tag BASEFONT = new Tag(72);
   public final Tag BASE = new Tag(53, true, false);
   public final Tag SELECT = new Tag(31, true, true);
   public final Tag OPTION = new Tag(54);
   // $FF: renamed from: U horst.parser.Tag
   public final Tag field_20 = new Tag(55);
   // $FF: renamed from: DT horst.parser.Tag
   public final Tag field_21 = new Tag(25, true, true);
   // $FF: renamed from: DD horst.parser.Tag
   public final Tag field_22 = new Tag(26, true, true);
   // $FF: renamed from: TT horst.parser.Tag
   public final Tag field_23 = new Tag(56, false, true);
   public final Tag CODE = new Tag(57, false, true);
   public final Tag SPAN = new Tag(46, false, true);
   public final Tag SUB = new Tag(58);
   public final Tag SUP = new Tag(59);
   public final Tag MENU = new Tag(61, true, true);
   public final Tag STYLE = new Tag(62, true, true);
   public final Tag NOSCRIPT = new Tag(63, true, true);
   public final Tag ADDRESS = new Tag(64, true, true);
   public final Tag NOBR = new Tag(65, false, true);
   public final Tag FORM = new Tag(66, true, false);
   public final Tag TEXTAREA = new Tag(32);
   public final Tag SAMP = new Tag(68);
   public final Tag SPACER = new Tag(69);
   public final Tag EMBED = new Tag(71);
   public final Tag NOEMBED = new Tag(75, false, true);
   public final Tag LAYER = new Tag(34, false, true);
   public final Tag NOLAYER = new Tag(77, false, true);
   public final Tag ILAYER = new Tag(78, false, true);
   public final Tag OBJECT = new Tag(76, false, true);
   public final Tag ABBR = new Tag(73, false, false);
   public final Tag ACRONYM = new Tag(74, false, false);
   private Hashtable m_tagHash = new Hashtable();

   public HTMLTags() {
      this.storeTag(this.DOCTYPE);
      this.storeTag(this.HTML);
      this.storeTag(this.BODY);
      this.storeTag(this.TABLE);
      this.storeTag(this.field_2);
      this.storeTag(this.field_0);
      this.storeTag(this.field_1);
      this.storeTag(this.field_3);
      this.storeTag(this.CENTER);
      this.storeTag(this.IMG);
      this.storeTag(this.field_4);
      this.storeTag(this.field_5);
      this.storeTag(this.field_6);
      this.storeTag(this.field_7);
      this.storeTag(this.field_8);
      this.storeTag(this.field_9);
      this.storeTag(this.field_10);
      this.storeTag(this.field_11);
      this.storeTag(this.field_12);
      this.storeTag(this.field_13);
      this.storeTag(this.field_14);
      this.storeTag(this.field_15);
      this.storeTag(this.field_16);
      this.storeTag(this.HEAD);
      this.storeTag(this.TITLE);
      this.storeTag(this.META);
      this.storeTag(this.STRONG);
      this.storeTag(this.SMALL);
      this.storeTag(this.field_18);
      this.storeTag(this.INPUT);
      this.storeTag(this.PRE);
      this.storeTag(this.FRAME);
      this.storeTag(this.FRAMESET);
      this.storeTag(this.NOFRAMES);
      this.storeTag(this.NOFRAME);
      this.storeTag(this.IFRAME);
      this.storeTag(this.APPLET);
      this.storeTag(this.PARAM);
      this.storeTag(this.field_19);
      this.storeTag(this.CAPTION);
      this.storeTag(this.MAP);
      this.storeTag(this.BLOCKQUOTE);
      this.storeTag(this.BIG);
      this.storeTag(this.AREA);
      this.storeTag(this.SCRIPT);
      this.storeTag(this.DIV);
      this.storeTag(this.LINK);
      this.storeTag(this.FONT);
      this.storeTag(this.BASEFONT);
      this.storeTag(this.BASE);
      this.storeTag(this.SELECT);
      this.storeTag(this.OPTION);
      this.storeTag(this.field_20);
      this.storeTag(this.field_21);
      this.storeTag(this.field_22);
      this.storeTag(this.CODE);
      this.storeTag(this.field_23);
      this.storeTag(this.SUP);
      this.storeTag(this.SUB);
      this.storeTag(this.field_17);
      this.storeTag(this.MENU);
      this.storeTag(this.STYLE);
      this.storeTag(this.NOSCRIPT);
      this.storeTag(this.ADDRESS);
      this.storeTag(this.NOBR);
      this.storeTag(this.FORM);
      this.storeTag(this.TEXTAREA);
      this.storeTag(this.SAMP);
      this.storeTag(this.SPACER);
      this.storeTag(this.SPAN);
      this.storeTag(this.EMBED);
      this.storeTag(this.NOEMBED);
      this.storeTag(this.ABBR);
      this.storeTag(this.ACRONYM);
      this.storeTag(this.LAYER);
      this.storeTag(this.NOLAYER);
      this.storeTag(this.ILAYER);
      this.storeTag(this.OBJECT);
      this.storeTag(this.DIR);
   }

   public Tag getTag(String name) {
      name = name.toLowerCase();
      Tag t = (Tag)this.m_tagHash.get(name);
      if (t != null) {
         t.clearAttributes();
      }

      return t;
   }

   public void storeTag(Tag t) {
      this.m_tagHash.put(t.getName(), t);
   }
}
