package horst.parser;

import java.util.Enumeration;
import java.util.Hashtable;

public class Tag {
   private Hashtable atts;
   private boolean blockTag;
   private boolean breakTag;
   // $FF: renamed from: id int
   private int field_0;

   public Tag(int id) {
      this(id, false, false);
   }

   public Tag(int id, boolean causesBreak, boolean isBlock) {
      this.field_0 = id;
      this.breakTag = causesBreak;
      this.blockTag = isBlock;
      this.atts = new Hashtable();
   }

   public boolean breaksFlow() {
      return this.breakTag;
   }

   public void clearAttributes() {
      this.atts.clear();
   }

   public Object getAttribute(Object key) {
      return this.atts.get(key);
   }

   public Hashtable getAttributes() {
      return this.atts;
   }

   public Hashtable getAttributesCopy() {
      Hashtable hash = new Hashtable();
      Enumeration e = this.atts.keys();

      while(e.hasMoreElements()) {
         Object key = e.nextElement();
         Object val = this.atts.get(key);
         hash.put(key, val);
      }

      return hash;
   }

   public int getID() {
      return this.field_0;
   }

   public String getName() {
      return HTMLDefs.getName(this.field_0);
   }

   public boolean isAttributeDefined(Object key) {
      return this.atts.containsKey(key);
   }

   public boolean isBlockTag() {
      return this.blockTag;
   }

   public void setAttribute(Object name, Object value) {
      this.atts.put(name, value);
   }

   public void setAttributes(Hashtable atts) {
      this.atts = atts;
   }
}
